//---------------------------------------------------------------------------
// Copyright (C) 2001 by Dmitriy Vassiliev
// slydiman@mailru.com
// http://slydiman.narod.ru
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "DevCmbWO.h"

#pragma package(smart_init)
#pragma resource "*.res"

//---------------------------------------------------------------------------
namespace Devcmbwo
{
    void __fastcall PACKAGE Register()
    {
        TComponentClass classes[1] = {__classid(TWaveOutDevCombo)};
        RegisterComponents("SlyDiman", classes, 0);
    }
}

//---------------------------------------------------------------------------
__fastcall TWaveOutDevCombo::TWaveOutDevCombo(TComponent* Owner) : TCustomComboBox(Owner)
{
  Sorted = false;
  FDefDriver = 0;
  Style = csDropDownList;
}

//---------------------------------------------------------------------------
void __fastcall TWaveOutDevCombo::CreateWnd(void)
{
  TCustomComboBox::CreateWnd();

  Init();
}

//---------------------------------------------------------------------------
void __fastcall TWaveOutDevCombo::Init(void)
{
  Items->Clear();

  WAVEOUTCAPS WaveOutCaps;
  int Devices = waveOutGetNumDevs();
  for( int i=-1; i<Devices; i++ ){
    if( waveOutGetDevCaps(i,&WaveOutCaps,sizeof(WAVEOUTCAPS)) != MMSYSERR_NOERROR )  break;
    Items->Add( WaveOutCaps.szPname );
  }

  ItemIndex = FDefDriver;
}

//---------------------------------------------------------------------------
void __fastcall TWaveOutDevCombo::SetDefDriver( int _Index )
{
  FDefDriver = _Index + 1;
  ItemIndex = FDefDriver;
}

//---------------------------------------------------------------------------
int __fastcall TWaveOutDevCombo::GetDefDriver( void )
{
  return( ItemIndex - 1 );
}

//---------------------------------------------------------------------------
