//---------------------------------------------------------------------------
// Copyright (C) 2001 by Dmitriy Vassiliev
// slydiman@mailru.com
// http://slydiman.narod.ru
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#ifndef DSDevCmdH
#define DSDevCmdH

//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <StdCtrls.hpp>

//---------------------------------------------------------------------------
#include <mmsystem.h>
#include <DSound.h>

//---------------------------------------------------------------------------
class PACKAGE TDSoundDevCombo : public TCustomComboBox
{
private:
    int FDefDriver;
    void __fastcall SetDefDriver(LPGUID);
    LPGUID __fastcall GetDefDriver(void);

protected:
    void __fastcall CreateWnd(void);
    void __fastcall DestroyWnd(void);

public:
  void __fastcall Init(void);

    __fastcall TDSoundDevCombo(TComponent* Owner);

    __property Items;
    __property Text;
    __property LPGUID DefaultDriver = {read=GetDefDriver,write=SetDefDriver};

__published:
//	__property Style ;
	__property Color ;
	__property Ctl3D ;
//	__property DragMode ;
//	__property DragCursor ;
	__property DropDownCount ;
	__property Enabled ;
//	__property Font ;
//	__property ImeMode ;
//	__property ImeName ;
	__property ItemHeight ;
//	__property Items ;
//	__property MaxLength ;
	__property ParentColor ;
	__property ParentCtl3D ;
	__property ParentFont ;
	__property ParentShowHint ;
	__property PopupMenu ;
	__property ShowHint ;
//	__property Sorted ;
	__property TabOrder ;
	__property TabStop ;
	__property Visible ;
	__property OnChange ;
	__property OnClick ;
	__property OnDblClick ;
//	__property OnDragDrop ;
//	__property OnDragOver ;
//	__property OnDrawItem ;
	__property OnDropDown ;
//	__property OnEndDrag ;
	__property OnEnter ;
	__property OnExit ;
//	__property OnKeyDown ;
//	__property OnKeyPress ;
//	__property OnKeyUp ;
//	__property OnMeasureItem ;
//	__property OnStartDrag ;
};

//---------------------------------------------------------------------------
#endif
