//---------------------------------------------------------------------------
// Copyright (C) 2001 by Dmitriy Vassiliev
// slydiman@mailru.com
// http://slydiman.narod.ru
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "DevCmbWI.h"

#pragma package(smart_init)
#pragma resource "*.res"

//---------------------------------------------------------------------------
namespace Devcmbwi
{
    void __fastcall PACKAGE Register()
    {
        TComponentClass classes[1] = {__classid(TWaveInDevCombo)};
        RegisterComponents("SlyDiman", classes, 0);
    }                         
}

//---------------------------------------------------------------------------
__fastcall TWaveInDevCombo::TWaveInDevCombo(TComponent* Owner) : TCustomComboBox(Owner)
{
  Sorted = false;
  FDefDriver = 0;
  Style = csDropDownList;
}

//---------------------------------------------------------------------------
void __fastcall TWaveInDevCombo::CreateWnd(void)
{
  TCustomComboBox::CreateWnd();

  Init();
}

//---------------------------------------------------------------------------
void __fastcall TWaveInDevCombo::Init(void)
{
  Items->Clear();

  WAVEINCAPS WaveInCaps;
  int Devices = waveInGetNumDevs();
  for( int i=-1; i<Devices; i++ ){
    if( waveInGetDevCaps(i,&WaveInCaps,sizeof(WAVEINCAPS)) != MMSYSERR_NOERROR )  break;
    Items->Add( WaveInCaps.szPname );
  }

  ItemIndex = FDefDriver;
}

//---------------------------------------------------------------------------
void __fastcall TWaveInDevCombo::SetDefDriver( int _Index )
{
  FDefDriver = _Index + 1;
  ItemIndex = FDefDriver;
}

//---------------------------------------------------------------------------
int __fastcall TWaveInDevCombo::GetDefDriver( void )
{
  return( ItemIndex - 1 );
}

//---------------------------------------------------------------------------
